import java.io.*;
import java.util.*;

public class ClientGen
{
	CGClientSpec clientSpec;
	BufferedReader reader;
	Random rand;
	
	public ClientGen() {
		clientSpec = new CGClientSpec();
		rand = new Random(0);
	}
	
	public void ShowMenu()
	{	
		System.out.print("1) Edit # Registrations [");
		if (clientSpec.isStaticNumRegs)
			System.out.println(clientSpec.staticNumRegs + "]");
		else
			System.out.println("N(" + clientSpec.numRegsMean + ", " +
				clientSpec.numRegsVar + ")]");
				
		System.out.print("2) Edit Speed [");
		if (clientSpec.isStaticSpeed)
			System.out.println(clientSpec.staticSpeed + "]");
		else
			System.out.println("N(" + clientSpec.speedMean + ", " +
				clientSpec.speedVar + ")]");
				
		System.out.print("3) Edit Cheating [");
		if (clientSpec.isStaticCheat)
			System.out.println(clientSpec.staticCheat + "]");
		else
			System.out.println("N(" + clientSpec.cheatMean + ", " +
				clientSpec.cheatVar + ")]");
				
		System.out.print("4) Edit Withdrawal [");
		if (clientSpec.isStaticWithdraw)
			System.out.println(clientSpec.staticWithdraw + "]");
		else
			System.out.println("N(" + clientSpec.withdrawMean + ", " +
				clientSpec.withdrawVar + ")]");

		System.out.print("5) Dump Client? [");
		if (clientSpec.dump)
			System.out.println("yes]");
		else
			System.out.println("no]");

		System.out.print("6) Edit Name [");
		System.out.println(clientSpec.name + "]");

		System.out.println("7) Generate Clients");
		System.out.println("8) New");
		System.out.println("9) Quit");
	}
	
	public void EditRegistrations() throws IOException
	{
		System.out.println("Enter new # of registrations:");
		String line = reader.readLine();
		line = line.toLowerCase();
		if (line.equals("n"))
		{
			clientSpec.isStaticNumRegs = false;
			System.out.println("Enter new mean:");
			line = reader.readLine();
			clientSpec.numRegsMean = Integer.valueOf(line).intValue();
			System.out.println("Enter new variance:");
			line = reader.readLine();
			clientSpec.numRegsVar = Double.valueOf(line).doubleValue();
			
			System.out.println("# of registrations changed to: N(" +
				clientSpec.numRegsMean + ", " + clientSpec.numRegsVar + ")");
		}
		else
		{
			clientSpec.isStaticNumRegs = true;
			clientSpec.staticNumRegs = Integer.valueOf(line).intValue();
			System.out.println("# of registrations changed to: " + clientSpec.staticNumRegs);
		}
	}
	
	public void EditRegistrations(boolean normal, int mean, int var) throws IOException
	{
		if (normal) {
			clientSpec.isStaticNumRegs = false;
			clientSpec.numRegsMean = mean;
			clientSpec.numRegsVar = var;
		} else {
			clientSpec.isStaticNumRegs = true;
			clientSpec.staticNumRegs = mean;
		}
	}
	
	public void EditSpeed() throws IOException
	{
		System.out.println("Enter new speed:");
		String line = reader.readLine();
		line = line.toLowerCase();
		if (line.equals("n"))
		{
			clientSpec.isStaticSpeed = false;
			System.out.println("Enter new mean:");
			line = reader.readLine();
			clientSpec.speedMean = Integer.valueOf(line).intValue();
			System.out.println("Enter new variance:");
			line = reader.readLine();
			clientSpec.speedVar = Double.valueOf(line).doubleValue();
			
			System.out.println("Speed changed to: N(" + clientSpec.speedMean + ", " +
				clientSpec.speedVar + ")");
		}
		else
		{
			clientSpec.isStaticSpeed = true;
			clientSpec.staticSpeed = Integer.valueOf(line).intValue();
			System.out.println("Speed changed to: " + clientSpec.staticSpeed);
		}
	}
	
	public void EditSpeed(boolean normal, int mean, int var) throws IOException
	{
		if (normal) {
			clientSpec.isStaticSpeed = false;
			clientSpec.speedMean = mean;
			clientSpec.speedVar = var;
		} else {
			clientSpec.isStaticSpeed = true;
			clientSpec.staticSpeed = mean;
		}
	}
	
	public void EditCheating() throws IOException
	{
		System.out.println("Enter new cheating probability:");
		String line = reader.readLine();
		line = line.toLowerCase();
		if (line.equals("n"))
		{
			clientSpec.isStaticCheat = false;
			System.out.println("Enter new mean:");
			line = reader.readLine();
			clientSpec.cheatMean = Double.valueOf(line).doubleValue();
			System.out.println("Enter new variance:");
			line = reader.readLine();
			clientSpec.cheatVar = Double.valueOf(line).doubleValue();
			
			System.out.println("Cheating prob changed to: N(" + clientSpec.cheatMean + ", " +
				clientSpec.cheatVar + ")");
		}
		else
		{
			clientSpec.isStaticCheat = true;
			clientSpec.staticCheat = Double.valueOf(line).doubleValue();
			System.out.println("Cheating prob changed to: " + clientSpec.staticCheat);
		}
	}
	
	public void EditCheating(boolean normal, int mean, int var) throws IOException
	{
		if (normal) {
			clientSpec.isStaticCheat = false;
			clientSpec.cheatMean = mean;
			clientSpec.cheatVar = var;
		} else {
			clientSpec.isStaticCheat = true;
			clientSpec.staticCheat = mean;
		}
	}
	
	public void EditWithdrawal() throws IOException
	{
		System.out.println("Enter new withdrawal rate:");
		String line = reader.readLine();
		line = line.toLowerCase();
		if (line.equals("n"))
		{
			clientSpec.isStaticWithdraw = false;
			System.out.println("Enter new mean:");
			line = reader.readLine();
			clientSpec.withdrawMean = Integer.valueOf(line).intValue();
			System.out.println("Enter new variance:");
			line = reader.readLine();
			clientSpec.withdrawVar = Double.valueOf(line).doubleValue();
			
			System.out.println("Withdrawal rate changed to: N(" + clientSpec.withdrawMean +
				", " + clientSpec.withdrawVar + ")");
		}
		else
		{
			clientSpec.isStaticWithdraw = true;
			clientSpec.staticWithdraw = Integer.valueOf(line).intValue();
			System.out.println("Withdrawal rate changed to: " + clientSpec.staticWithdraw);
		}
	}
	
	public void EditWithdrawal(boolean normal, int mean, int var) throws IOException {
		if (normal) {
			clientSpec.isStaticWithdraw = false;
			clientSpec.withdrawMean = mean;
			clientSpec.withdrawVar = var;
		} else {
			clientSpec.isStaticWithdraw = true;
			clientSpec.staticWithdraw = mean;
		}
	}

	public void EditDump() throws IOException
	{
		System.out.println("Should client dump?");
		String line = reader.readLine();
		line = line.toLowerCase();
		if (line.equals("y"))
		{
			clientSpec.dump = true;
			System.out.println("Client will now dump stats.");
			if (clientSpec.name.equals(""))
			{
				System.out.println("Client must have name:");
				EditName();
			}
		}
		else
		{
			clientSpec.dump = false;
			System.out.println("Client will not dump stats.");
		}
	}

	public void EditName() throws IOException
	{
		System.out.println("Enter new name:");
		String line = reader.readLine();
		clientSpec.name = new String(line);
		System.out.println("Name changed to: " + line);
	}		

	
	public void CreateClients() throws IOException
	{
		System.out.print("Enter file name to create: ");
		String filename = reader.readLine();
		
		System.out.print("Enter # of clients to create: ");
		int n = Integer.valueOf(reader.readLine()).intValue();
		
		int i, j;
		Client client;
		Registration reg;
		int speed = 0;
		int numRegs = 0;
		int withdraw = 0;
		double cheat = 0;
		
		if (clientSpec.isStaticNumRegs)
			numRegs = clientSpec.staticNumRegs;
		if (clientSpec.isStaticSpeed)
			speed = clientSpec.staticSpeed;
		if (clientSpec.isStaticWithdraw)
			withdraw = clientSpec.staticWithdraw;
		if (clientSpec.isStaticCheat)
			cheat = clientSpec.staticCheat;
	
		XMLHandler out = new XMLHandler(XMLHandler.NEW,"clients");
		
		for (i = 0; i < n; i++)
		{
			if (!clientSpec.isStaticNumRegs)
				numRegs = NormalInt(clientSpec.numRegsMean, clientSpec.numRegsVar);
			if (!clientSpec.isStaticSpeed)
				speed = NormalInt(clientSpec.speedMean, clientSpec.speedVar);
			if (!clientSpec.isStaticWithdraw)
				withdraw = NormalInt(clientSpec.withdrawMean, clientSpec.withdrawVar);
			if (!clientSpec.isStaticCheat)
				cheat = Normal(clientSpec.cheatMean, clientSpec.cheatVar);
				
			client = new Client(null, speed, cheat, withdraw, clientSpec.dump, clientSpec.name);
			for (j = 0; j < numRegs; j++)
				client.AddRegistration(new Registration(client));
			
			out.Append(client.Write(out.GetDocument()));
		}
		
		out.SaveXML(filename);
	}
	
	public void CreateClients(String filename, int n) throws IOException
	{		
		int i, j;
		Client client;
		Registration reg;
		int speed = 0;
		int numRegs = 0;
		int withdraw = 0;
		double cheat = 0;
		
		if (clientSpec.isStaticNumRegs)
			numRegs = clientSpec.staticNumRegs;
		if (clientSpec.isStaticSpeed)
			speed = clientSpec.staticSpeed;
		if (clientSpec.isStaticWithdraw)
			withdraw = clientSpec.staticWithdraw;
		if (clientSpec.isStaticCheat)
			cheat = clientSpec.staticCheat;
	
		XMLHandler out = new XMLHandler(XMLHandler.NEW,"clients");
		
		for (i = 0; i < n; i++)
		{
			if (!clientSpec.isStaticNumRegs)
				numRegs = NormalInt(clientSpec.numRegsMean, clientSpec.numRegsVar);
			if (!clientSpec.isStaticSpeed)
				speed = NormalInt(clientSpec.speedMean, clientSpec.speedVar);
			if (!clientSpec.isStaticWithdraw)
				withdraw = NormalInt(clientSpec.withdrawMean, clientSpec.withdrawVar);
			if (!clientSpec.isStaticCheat)
				cheat = Normal(clientSpec.cheatMean, clientSpec.cheatVar);
				
			client = new Client(null, speed, cheat, withdraw, clientSpec.dump, clientSpec.name);
			for (j = 0; j < numRegs; j++)
				client.AddRegistration(new Registration(client));
			
			out.Append(client.Write(out.GetDocument()));
		}
		
		out.SaveXML(filename);
	}
	
	public int NormalInt(double mean, double variance)
	{
		return (int)Math.abs(Math.rint(Normal(mean, variance)));
	}
	
	public double Normal(double mean, double variance)
	{
		return Math.abs(rand.nextGaussian() * Math.sqrt(variance) + mean);
	}
	
	public void ProcessMenuInput(int n) throws IOException
	{	
		switch (n)
		{
			case 1:
				EditRegistrations();
				break;
			case 2:
				EditSpeed();
				break;
			case 3:
				EditCheating();
				break;
			case 4:
				EditWithdrawal();
				break;
			case 5:
				EditDump();
				break;
			case 6:
				EditName();
				break;
			case 7:
				CreateClients();
				break;
			case 8:
				clientSpec = new CGClientSpec();
				break;
			case 9:
				System.exit(0);
				break;
			default:
				System.out.println("Invalid input!");
		}
	}
	
	public void Run()
	{
		try
		{
			reader = new BufferedReader(new InputStreamReader(System.in));
		
			while (true)
			{
				ShowMenu();
				System.out.print("> ");
				int n;
				while (true) {
					String line = reader.readLine();
					boolean b = false;
					for (int i = 0; i < line.length(); i++) {
						if (!Character.isDigit(line.charAt(i))) {
							System.out.println("Please enter a valid number");
							System.out.print("> ");
							b = true;
							break;
						}
					}
					if (b) continue;
					n = Integer.valueOf(line).intValue();
					break;
				}
				ProcessMenuInput(n);
			}
		}
		catch (IOException e)
		{
			System.err.println(e);
		}
	}
	
	public static void main(String[] args) {
		
		if (args.length == 0) {
			ClientGen cg = new ClientGen();
			cg.Run();
		} else {
			try {
				ClientGen cg = new ClientGen();
				
				int cur = 0;
				while (cur < args.length - 2) {
					switch (args[cur++].charAt(0)) {
					case 'r':case 'R':
						if (args[cur].charAt(0) == 'n') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							int v = Integer.parseInt(args[cur++]);
							cg.EditRegistrations(true,m,v);
						} else if (args[cur].charAt(0) == 'f') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							cg.EditRegistrations(false,m,0);
						}
						break;
					case 's':case 'S':
						if (args[cur].charAt(0) == 'n') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							int v = Integer.parseInt(args[cur++]);
							cg.EditSpeed(true,m,v);
						} else if (args[cur].charAt(0) == 'f') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							cg.EditSpeed(false,m,0);
						}
						break;
					case 'c':case 'C':
						if (args[cur].charAt(0) == 'n') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							int v = Integer.parseInt(args[cur++]);
							cg.EditCheating(true,m,v);
						} else if (args[cur].charAt(0) == 'f') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							cg.EditCheating(false,m,0);
						}
						break;
					case 'w':case 'W':
						if (args[cur].charAt(0) == 'n') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							int v = Integer.parseInt(args[cur++]);
							cg.EditWithdrawal(true,m,v);
						} else if (args[cur].charAt(0) == 'f') {
							cur++;
							int m = Integer.parseInt(args[cur++]);
							cg.EditWithdrawal(false,m,0);
						}
						break;
					}
				}
				
				String f = args[cur++];
				int n = Integer.parseInt(args[cur++]);
				cg.CreateClients(f,n);
				  
			} catch (IOException ioe) {
				System.out.println(ioe);
			}
		}
	}
}
