// Registration.java

/*
 * Rishi Kacker and Matt Pauker
 * Started: 05/12/2001
 */

import java.util.*;
import org.w3c.dom.*;

public class Registration
{	
	private LinkedList taskList;
	
	private int registered;
	private double money;
	private double activity;
	private Client client;
	private int tasksWanted;
	private int speed;
	private int tasksAssigned;
	public int ts;
	
	public final static int PLEDGE = 1;
	public final static int ACTIVE = 2;

	public Registration(Client client) {
		taskList = new LinkedList();
		registered = Settings.REGISTRATION_PERIOD;
		this.client = client;
		activity = 0;
		money = 0;
		speed = client.GetSpeed();
		tasksWanted = speed;
		tasksAssigned = 0;
	}
	
	public Registration(Client client, int registered, double money, double activity) {
		// we are assuming empty task list when reading from file
		taskList = new LinkedList();
		this.client = client;
		this.registered = registered;
		this.activity = activity;
		this.money = money;
		speed = client.GetSpeed();
		tasksWanted = speed;
		tasksAssigned = 0;
	}
	
	public void normalize(double norm) {
		activity = activity/norm;
	}
	
	public void Restart()
	{
		tasksWanted = speed;
		tasksAssigned = 0;
	}
	
	// Returns the number of tasksleft
	public int ExecuteTask() {
		for (int i = 0; i < speed; i++) {
			if (taskList.size() > 0) {
				Task t = (Task)taskList.removeFirst();
				
				// fix this later, depending on cheating
				t.setAnswer(true,this);
				//
				
			}
		}
		
		ts = taskList.size();
		
		taskList = new LinkedList();
		
		return ts;
	}
	
	public void SetActivity(double activity) {
		this.activity = activity;
	}
	
	public void UpdateActivity() {

		// The activity is based on the last rounds execution
		//
		//System.out.println("Average tasks: " + client.AverageTasksLeft());
		//System.out.println("TS " + ts);
		
		////////////////Old Method, error when activity < 0
		/*
		double act = activity * 
					 (1 + Settings.GetElasticity() * 
						  (client.AverageTasksLeft() - ts));
		*/
		
		////////////////Ilya Method of (average tasks lefts/my tasks left)^e
		
		double act = activity *
					 Math.pow((1 + client.AverageTasksLeft())/(1 + ts),Settings.GetElasticity());
		
		////////////////////////
		
		////////////////Method of [Max (0, Multiplier)]
/*
		double diff = client.AverageTasksLeft() - ts;
		if (diff < 0) diff = 0.0;
		double act = activity * (1 + Settings.GetElasticity() * diff);
*/		
		//if (act < Settings.MIN_BOUND) act = Settings.MIN_BOUND;
		
		//System.out.println("ACT: " + activity + " NEW: " + act);
		
		// We make the assumption that if activity becomes less than a lower bound
		// We reset them to the that lower bound
		//if (act < Settings.MIN_BOUND)
		//	act = Settings.MIN_BOUND;
		
		//System.out.println("CALCULATED ACT: " + act);
		
		switch(Settings.GetActivityMode()) {
			case Settings.VARIABLE_RESOURCES:
				activity = act;
				break;
			case Settings.VARIABLE_RESOURCES_MAX:
				if (act > Settings.MAX_ACTIVITY)
					activity = Settings.MAX_ACTIVITY;
				else
					activity = act;
				break;
			case Settings.CONSTANT_RESOURCES:
				activity = 1;
				break;
		}
	}
	
	public double GetActivity() {return activity;}
	
	public void AddTask(Task t) {
		taskList.addLast(t);
		tasksWanted--;
		tasksAssigned++;
	}
	
	public double GetMoney() {return money;}
	
	public boolean IsRegistered() {
		return (registered == 0);
	}
	
	public double Withdraw() {
		double m = money;
		money = 0;
		return m;
	}

	// Assume constant payment here for all tasks (1 unit)
	public double Pay(double amt) {
		if (registered > 0)
		{
			registered--;
			return 0;
		}
		money+=amt;
		return amt;
	}

	public void Kill() {}

	public Client GetClient() {return client;}
	
	public int NumTasksWanted()
	{
		// return tasksWanted; !!! 
		return 1;
	}
	
	public int GetAssigned()
	{
		return tasksAssigned;
	}
	
	//XML tags
	private final static String REGISTRATION = "registration";
	private final static String REGISTERED = "registered";
	private final static String MONEY = "money";
	private final static String ACTIVITY = "activity";
	
	public Element Write(Document doc) {
		Element node = doc.createElement(REGISTRATION);
		node.setAttribute(REGISTERED, Integer.toString(registered));
		node.setAttribute(MONEY, Double.toString(money));
		node.setAttribute(ACTIVITY, Double.toString(activity));
		return node;
	}
}
