//Task.java

/*
 * Rishi Kacker and Matt Pauker
 * Started: 05/12/2001
 */ 

import java.util.*;

public class Task
{

	// Registrations to whom the task is currently assigned
	private ArrayList currentAssigns;
	// Registrations to whom the task was previously assigned (i.e. it had
	// to be reassigned)
	private ArrayList prevAssigns;
	
	// Whether the task has been completed or not
	private boolean done;
 
	public Task()
	{
		currentAssigns = new ArrayList();
		prevAssigns = null;
		done = false;
	}
	
	// Add a registration who will be processing this task
	public void AddRegistration(Registration r, double payment)
	{
		Assignment a = new Assignment(r, false, payment);
		currentAssigns.add(a);
	}
	
	// Set the task up to be reassigned and computed by a new
	// set of registrations
	public void restart()
	{
		if (prevAssigns == null)
			prevAssigns = new ArrayList();
			
		prevAssigns.addAll(currentAssigns);
		currentAssigns.clear();
	}
	

	// Matt: Don't think should ever return this entire thing.
	// Better to write function which use the arrays

	// Returns the list of current assignments
	public ArrayList getCurrentAssigns()
	{
		return currentAssigns;
	}
	
	// Returns the list of any previous assignments
	public ArrayList getPrevAssigns()
	{
		return prevAssigns;
	}
	
	/*
	public int Calculation(int status) {
		if (status == Registration.PLEDGE)
			// Assume no cheating and correctness during registration
			return 0;
		else {
			// Do some sort of dummy calculation or print here
			// Needs to return the amount paid for task;
			return 0;
		}
	}
	*/
	
	public boolean isDone()
	{
		return done;
	}
	
	public void setDone(boolean done)
	{
		this.done = done;
	}
	
	public void setAnswer(boolean answer, Registration forReg)
	{
		int i;
		
		for (i = 0; i < currentAssigns.size(); i++)
		{
			Assignment a = (Assignment)currentAssigns.get(i);
			if (a.reg == forReg)
				a.answer = answer;
		}
	}

}
